Subject: Re: [PATCH net-next 0/5][pull request] ice: Support 5 layer Tx scheduler topology

From: Jakub Kicinski <[email-masked]>
Date: Wed, 24 May 2023 13:02:40 -0700

On Wed, 24 May 2023 18:59:20 +0200 Wilczynski, Michal wrote:
>  [...]  
> >> I wouldn't say it's a FW bug. Both approaches - 9-layer and 5-layer
> >> have their own pros and cons, and in some cases 5-layer is
> >> preferable, especially if the user desires the performance to be
> >> better. But at the same time the user gives up the layers in a tree
> >> that are actually useful in some cases (especially if using DCB, but
> >> also recently added devlink-rate implementation).  
> > I didn't notice mentions of DCB and devlink-rate in the series.
> > The whole thing is really poorly explained.  
> 
> Sorry about that, I gave examples from the top of my head, since those are the
> features that potentially could modify the scheduler tree, seemed obvious to me
> at the time. Lowering number of layers in the scheduling tree increases performance,
> but only allows you to create a much simpler scheduling tree. I agree that mentioning the
> features that actually modify the scheduling tree could be helpful to the reviewer.

Reviewer is one thing, but also the user. The documentation needs to be
clear enough for the user to be able to confidently make a choice one
way or the other. I'm not sure 5- vs 9-layer is meaningful to the user
at all. In fact, the entire configuration would be better defined as
a choice of features user wants to be available and the FW || driver
makes the decision on how to implement that most efficiently.